//
// Cthugha - Audio Seeded Image Processing
//
// Zaph, Digital Aasvogel Group, Torps Productions 1993-1994
//


// This is an example program of how to generate rotating tables.
//
// Feel free to change the code, make your own, and send me the 
// resulting .TAB file for inclusion in the next version!!
//
// For more info, check CTHUGHA.DOC (and hope I got around to writing
// that section!
//
// Currently it is configured for a single spiral, with grainy randomness
//

#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <time.h>

#include "cthugha.h"

unsigned int map;

#define M_PI 3.14159265358979323846
#define RADEG (180.0/M_PI)

char maptabfile[255];

int centersX[10];
int centersY[10];
int dir[10];

int main(int argc, char **argv)
{
	int x,y,map_x,map_y,i;
	int closest;
	double dist;
	double polar_r,polar_a;
	double delta_r=2.0,delta_a=0.1;
	double temp_y,temp_x;
	double cent_y,cent_x;
	long l;

	FILE *fp;


	argc--; argv++;
	if (argc) {
		strcpy(maptabfile,*argv);
		printf("Generating table: %s\n",maptabfile);
	} else {
		printf("Gentable usage:\n\tgentable tabname.tab <(float)delta_r> <(float)delta_a>\n");
		exit(1);
	}

	argc--; argv++;
	if (argc) {
		delta_r=atof(*argv);
	}
	argc--; argv++;
	if (argc) {
		delta_a=atof(*argv);
	}

	time(&l);
	srand(l);

	for (i=0; i<10; i++) {
		centersX[i]=rand()%320;
		centersY[i]=rand()%200;
		dir[i]=rand()%5-2;
	}


	if ((fp=fopen(maptabfile,"wb"))!=NULL) {
		printf("Writing mapping table: %s\n",maptabfile);
		for (y=0; y<BUFF_HEIGHT; y++) {
			printf("%3d/%3d \r",y+1,BUFF_HEIGHT);

			for (x=0; x<BUFF_WIDTH; x++) {
				closest=0;
				dist=9999999.0;

				temp_x=x;
				temp_y=y;
				for (i=0; i<10; i++) {
					if (dist>(sqrt((temp_x-centersX[i])*(temp_x-centersX[i])+
						(temp_y-centersY[i])*(temp_y-centersY[i])))) {
							closest=i;
							dist=sqrt((temp_x-centersX[i])*(temp_x-centersX[i])+
								(temp_y-centersY[i])*(temp_y-centersY[i]));
						}
				}

				if ((x==centersX[closest]) && (y==centersY[closest])) {
					map=0;
				} else {
					cent_y=centersY[closest];
					cent_x=centersX[closest];
					temp_x=abs(x-cent_x);
					temp_y=abs(y-cent_y);

					polar_r=sqrt(temp_x*temp_x + temp_y*temp_y);
					polar_a=atan2((double)(x-cent_x),(double)(y-cent_y));


					polar_r += (delta_r+(rand()%10)*0.01)*(double)dir[closest];

					if (polar_r<0)
						polar_r=0.0;

					polar_a += (delta_a+(rand()%10)*0.01)*(double)dir[closest];

//					polar_a += (delta_a * (float)(5-(int)(polar_r/11)%11)/5.0);
//					if (((int)(polar_r/10)%2)) {
//						polar_a += delta_a;
//					} else {
//						polar_a -= delta_a;
//					}

					temp_y=polar_r*(cosl(polar_a));
					temp_x=polar_r*(sinl(polar_a));

					map_x=temp_x+cent_x;
					map_y=temp_y+cent_y;

					if ((map_y>=BUFF_HEIGHT) || (map_y<0) ||
						(map_x>=BUFF_WIDTH) || (map_x<0) ) {
						map_x=0;
						map_y=0;
					}

					map_x=max(map_x,0);
					map_y=max(map_y,0);

					map=map_y*BUFF_WIDTH+map_x;

				}
				fwrite(&map,sizeof(int),1,fp);
			}
		}

		fclose(fp);
	}

}


